package org.zeroturnaround.javarebel.integration.tapestry4;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class Tapestry4ListenerMapImplBCP extends
		JavassistClassBytecodeProcessor {
	private String insertBeforeStr = 
			"org.apache.tapestry.listener.ListenerMethodInvoker invoker2 = (org.apache.tapestry.listener.ListenerMethodInvoker) _invokers.get($1);\n"
			+ "try {\n"
			+ "	if (invoker2 == null) {\n"
			+ "		// lets reinit the cache\n"
			+ "		org.apache.tapestry.listener.ListenerMapSourceImpl impl = new org.apache.tapestry.listener.ListenerMapSourceImpl();\n"
			+ "							\n"
			+ "		java.lang.reflect.Method m = org.apache.tapestry.listener.ListenerMapSourceImpl.class.getDeclaredMethod(\"findInvokerMap\", new Class[]{Class.class});\n"
			+ "		m.setAccessible(true);\n"
			+ "		java.util.Map newCache = (java.util.Map)m.invoke(impl, new Class[]{_target.getClass()});\n"
			+ "		_invokers.clear();\n"
			+ "		_invokers.putAll(newCache);\n"
			+ "	}\n"
			+ "}\n"
			+ "catch (Exception e) {\n"
			+ "	org.zeroturnaround.javarebel.LoggerFactory.getInstance().log(\"Exception with Tapestry integration - NOT FATAL!\");\n"
			+ "	org.zeroturnaround.javarebel.LoggerFactory.getInstance().error(e);\n"
			+ "	e.printStackTrace();\n"
			+ "}";

	public static void main(String[] args) {
		Tapestry4ListenerMapImplBCP tmp = new Tapestry4ListenerMapImplBCP();
		System.out.println(tmp.insertBeforeStr);
	}

	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
		CtMethod m = ctClass.getMethod("createListener", "(Ljava/lang/String;)Lorg/apache/tapestry/IActionListener;");

		m.insertBefore(insertBeforeStr);
	}
}
